import { Component, OnInit } from '@angular/core';
import { ExcelUtility } from "./ExcelUtility";


@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss']
})
export class AppComponent implements OnInit {
  title = 'kb3886-app2';

  public gridData: any[] = [];

  constructor() {
  }

  ngOnInit(): void {
    this.gridData = [];
    for(let i = 0; i < 5; i++){
      this.gridData.push({ID: i, TaskName: "Task " + i, Assignee: "担当者" + i, Progress: Math.floor(Math.random () * 11) * 10 });
    }
  }

  public async changeFile(event:any, files: any): Promise<void> {
    // Workbookの読み込み
    let workbook = await ExcelUtility.load(files[0]);

    // gridDataの記入
    let rowOffset = 5;
    let cellOffset = 1;
    let keys = Object.keys(this.gridData[0]);
    for(let i = 0; i < this.gridData.length; i++ ){
      for(let j = 0; j < keys.length; j++){
        workbook.worksheets(0).rows(i + rowOffset).cells(j + cellOffset).value = this.gridData[i][keys[j]];
      }
    }

    // Workbookの保存
    ExcelUtility.save(workbook, "TaskProgress");
  }
}
